﻿/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
module pes.prompt;

// Windows command prompt 用

version(Win32)
{

private import 	std.utf,
				std.string,
				std.stream,
				std.windows.charset;
import std.cstream;

// ここにCFileを継承したようなクラスを作ろうと思う！

char[] readLine(Stream stream)
{
	ubyte[] 	line;
	ubyte		c;
	
	while (! stream.eof) {
		size_t size = stream.readBlock(&c, ubyte.sizeof);
		if (size == 0) {
			break;
		}
		line ~= c;
		if (c == '\n') {
			break;
		}
	}
	
	return mbsToUTF8(line);
}

void mbswritef(CFile fp, ...)
{
	char[] 	s;
	ubyte[] mbs;
	
	void puts(dchar c) {
		std.utf.encode(s, c);
	}
	std.format.doFormat(&puts, _arguments, _argptr);
	
//	s 	= std.string.replace(s, "\n", "\r\n");
	mbs	= utf8ToMBS(s);
	
	fp.writeBlock(mbs.ptr, mbs.length);
}

void writeString(Stream stream, char[] s)
{
	ubyte[] mbs = utf8ToMBS(s);
	stream.writeBlock(mbs, mbs.length);
}

ubyte[] utf8ToMBS(char[] s)
{
/*
	if (s.length == 0) {
		return null;
	}

	char[] result;
	int i;
	wchar* ws = std.utf.toUTF16z(s);
	
	result.length = WideCharToMultiByte(0, 0, ws, -1, null, 0, null, null);
	i = WideCharToMultiByte(0, 0, ws, -1, result, result.length, null, null);
	assert(i == result.length);
	
	if (result.length > 0) {
		result.length = result.length -1; // Exclude null char at end.
	}
	
	return cast(ubyte[])result;
*/
	ubyte[] mbs;
	
	try {
		mbs = cast(ubyte[])toString(toMBSz(s));
	} catch (Exception e) {
		// いやだ･･･
		mbs = cast(ubyte[])e.toString;
	}
	
	return mbs;
}

char[] mbsToUTF8(ubyte[] mbs)
{
/*
	if (mbs.length == 0) {
		return null;
	}

	const uint wweight = (wchar.sizeof/byte.sizeof);
	char[] result;
	int i;
	wchar[] ws;
	char *smbs = std.string.toStringz(cast(char[])mbs);
	
	ws.length = MultiByteToWideChar(0, 0, smbs, -1, null, 0);
	i = MultiByteToWideChar(0, 0, smbs, -1, ws, ws.length);
	assert(i == ws.length);
	
	if (ws.length > 0) {
		ws.length = ws.length -1;	// Exclude null char at end.
	}
	result = std.utf.toUTF8(ws);
	
	return result;
*/
	char[] utf8string;
	try {
		utf8string = fromMBSz(toStringz(cast(char[])mbs));
	} catch (Exception e) {
		// いやだ･･
		utf8string = e.toString;
	}
	
	return utf8string;
}

} else {
	pragma(msg, "warning: pes.prompt: not implemented for this compiler version")
	static assert(0);
}
