﻿/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
module pes.rc4;

// RC4 crypt (注意!! Winny用に改造中!)

class RC4
{
protected:
	uint 	m_x;
	uint 	m_y;
	ubyte	m_state[256];

public:
	this(ubyte[] rc4_key)
	{
//		m_state = new ubyte[256];
		key(rc4_key);
	}
	
	this(){
//		m_state = new ubyte[256];
	}
	
	static ubyte[] crypt(ubyte[] key, ubyte[] src)
	{
		ubyte[256] state;
		uint x, y;
		
		arc4Initialize(key, x, y, state);
		return arc4Crypt(src, x, y, state);
	}
	
	ubyte[] crypt(ubyte[] src)
	{
		return arc4Crypt(src, m_x, m_y, m_state);
	}
	
	void key(ubyte[] key)
	{
		arc4Initialize(key, m_x, m_y, m_state);
	}
}


public void arc4Initialize(ubyte[] key, inout uint mx, inout uint my, ubyte[256] mstate)
{
	uint u, i;
	uint keyindex;
	ubyte stateindex;
	ubyte *pstate;
	
	mx = 0;
	my = 0;
	
	// Winny用に0までをキーとする
	for (i = 0; i < key.length; ++i) {
		if (key[i] == 0) {
			if (i == 0) {
				key.length = 1;
			} else {
				key.length = i;
			}
			break;
		}
	}
	
	pstate = mstate.ptr;
	for (i = 0; i < mstate.length; ++i) {
		*pstate++ = i;
	}
	
	if (key.length == 0) {
		return;
	}
	
	keyindex	= 0;
	stateindex	= 0;
	
	pstate = mstate.ptr;
	for (i = 0; i < mstate.length; ++i) {
		ubyte state = *pstate;
		ubyte *pstateindex;
		
		stateindex 			= stateindex + key[keyindex] + state;
		pstateindex			= mstate.ptr + stateindex;
		u 					= *pstateindex;
		*pstateindex		= state;
		*pstate++ 			= u;
		if (++keyindex >= key.length) {
			keyindex = 0;
		}
	}
}

public ubyte[] arc4Crypt(ubyte[] src, inout uint mx, inout uint my, ubyte[256] mstate)
{
	ubyte x	= mx;
	ubyte y	= my;
	
	ubyte sx, sy;
	uint srclen = src.length;
	ubyte *psrc = src.ptr;
	
	while (srclen-- != 0) {
		++x;
		sx				= mstate[x];
		y				+= sx;
		sy				= mstate[y];
		mstate[y] 		= sx;
		mstate[x] 		= sy;
		sx				+= sy;
		
		*psrc++ ^= mstate[sx];
	}
	
	mx = x;
	my = y;
	
	return src;
}

debug(rc4)
{
	import std.stdio;
	import pes.dump;;
	
	int main()
	{
		static ubyte[] key1	= [ 0xD2, 0x46, 0xAD, 0x10];
		static ubyte[] key2	= [ 0x39, 0x38, 0x37, 0x38, 0x39, 0x61, 0x73, 0x6a ];
		static ubyte[] src 	= [
 			0xDC, 0x9A, 0x1E, 0xF9, 0x71, 0xAE, 0xC3, 0x4C, 0x8A, 0xFD, 0x8B, 0xE9, 0x88, 0x7A, 0x7B, 0x21,
			0x23, 0xBD, 0xAA, 0x76, 0x9E, 0x8A, 0x63, 0xDB, 0x01, 0x5D
		];
		ubyte[] enc;
		RC4 rc4 = new RC4(key1);
		
		enc = rc4.crypt(src);
		hexdump(enc);
		enc[10 .. length] = RC4.crypt(key2, enc[10 .. length]);
		hexdump(enc);
		
		return 0;
	}
}

